// #autoload
// #name = DioGrabCall
// #version = 1.0
// #date = 8/2/2002 11:32AM
// #status = beta
// #author = |Rx|Diogenes
// #warrior = Diogenes
// #email = diogenes@tribalpharmacy.com
// #web = http://www.tribalpharmacy.com
// #description = HUD to track who's "called" the flag. VFF biotch, call your shit or stop complaining.
// #include = support/callback.cs
// #category = DioScripts

if(!isobject(DioGrabCall)){
	new ScriptObject(DioGrabCall){
		class = DioGrabCall;
	};		
}

package DioGrabCall{

	function DioGrabCalled(%caller){
		DioGrabCall.schedule = 0;
		DioGrabCall.FlagCalled = true;
		DioGrabCall.Caller = %caller;
		$DioGrabCallTimer = 10;
		DioGrabCallHUD.Caller.setprofile("DGCTimerWhite");
		DioGrabCallHUD.Timer.setprofile("DGCTimerWhite");
		DioGrabCallHUD.Caller.setvalue(%caller);
		DioGrabCallHUD.Timer.setvalue($DioGrabCallTimer);
		DioGrabCallHUD.SetVisible(true);
		DioGrabCall.schedule = schedule(1000, 0, DioGrabCallUpdate);
	}
	
	function DioGrabCallUpdate(){
		if (DioGrabCall.schedule != 0) cancel(DioGrabCall.schedule);
		$DioGrabCallTimer--;
		DioGrabCallHUD.Timer.setvalue($DioGrabCallTimer);
		DioGrabCall.schedule = schedule(1000, 0, DioGrabCallUpdate);
		if($DioGrabCallTimer $= 3){
			DioGrabCallHUD.Timer.setprofile("DGCTimerRed");
		}
		if($DioGrabCallTimer $= 0){
			DioGrabCall.Clear();
		}
	}
	
	function DioGrabCall::Clear(){
		cancel(DioGrabCall.schedule);
		DioGrabCall.schedule = 0;
		DioGrabCallHUD.setvisible(false);
		DioGrabCall.FlagCalled = false;	
		alxPlay( InputDeniedSound, 0, 0, 0);
	}
	
	function clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10) {
		%msg=detag(%msgString);
		if(strstr(%msg,"flg.flag") != -1 && DioGrabCall.FlagCalled != true){
			%caller = $PlayerList[%sender].name;
			DioGrabCalled(%caller);
		}
		parent::clientCmdChatMessage(%sender, %voice, %pitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
	}
	
	function DioGrabCall::Grab(%this, %msgType, %msgString, %name, %teamName, %team, %nameBase){
		if(DioGrabCall.FlagCalled){
			%team = detag(%team);
			if(%team !$= DioFlagHUD.MyTeam){
				%grabber = detag(%name);
				if(%grabber !$= DioGrabCall.Caller){
					%hudmsg = "\c5" @ %grabber @ " just stole " @ DioGrabCall.Caller @ "'s flag grab.";
					defaultmessagecallback('', %hudmsg);
				}
				DioGrabCall.Clear();

			}
		}
	}
	
	function DioGrabCall::SetTeam(%this, %msgType, %msgString, %clientName, %teamName, %clientId, %teamId){
		if(DioFlagHUD.MyID == %clientId){
			DioGrabCall.MyTeam = detag(%teamId); 
		}
	}
	
	function DioGrabCall::Connect(%this, %msgType, %msgString, %clientName, %clientId, %targetId, %isAI, %isAdmin, %isSuperAdmin, %isSmurf, %guid){
		if (strstr(%msgString, "Welcome to Tribes2") != -1){
			DioGrabCall.MyTeam = detag(%teamId); 
		}
	}	
	                         
	function DioGrabCall::Death(%this, %msgType, %msgString, %victimName, %victimGender, %victimPoss, %killerName, %killerGender, %killerPoss, %damageType){
		%victimName = detag(%victimName);
		if(DioGrabCall.FlagCalled && %victimName $= DioGrabCall.Caller){
			DioGrabCallHUD.Caller.setvalue("<color:FF0000>" @ DioGrabCall.Caller);
			DioGrabCall.schedule(500, Clear);
		}
	}

	function DioGrabCall::setup(%this){
		new GuiControlProfile ("DGCTimerWhite"){
	                fontType = "Univers Bold";
	                fontSize = 16;
	                fontColor = "255 255 255";
	                justify = "right";
	        }; 
	        
		new GuiControlProfile ("DGCTimerRed"){
	                fontType = "Univers Bold";
	                fontSize = 16;
	                fontColor = "255 0 0";
	                justify = "right";
	        };   
		new GuiControlProfile ("DGCCallerWhite"){
	                fontType = "Univers Bold";
	                fontSize = 16;
	                fontColor = "255 255 255";
	                justify = "right";
	        }; 
	             		           
	
		//Catch our Grabs
		callback.add(CallbackMsgCTFFlagTaken, "DioGrabCall.Grab");
		callback.add(CallbackMsgClientJoin, "DioGrabCall.Connect");
		callback.add(CallbackMsgClientJoinTeam, "DioGrabCall.SetTeam");
		//Catch Deaths
		callback.add(CallbackMsgLegitKill,"DioGrabCall.Death");
		callback.add(CallbackMsgTeamKill,"DioGrabCall.Death");
		callback.add(CallbackMsgHeadShotKill,"DioGrabCall.Death");
		callback.add(CallbackMsgSuicide,"DioGrabCall.Death");
		callback.add(CallbackMsgSelfKill,"DioGrabCall.Death");
		callback.add(CallbackMsgTurretSelfKill,"DioGrabCall.Death");
		callback.add(CallbackMsgVehicleKill,"DioGrabCall.Death");
		callback.add(CallbackMsgVehicleSpawnKill,"DioGrabCall.Death");
		callback.add(CallbackMsgVehicleCrash,"DioGrabCall.Death");
		callback.add(CallbackMsgTurretKill,"DioGrabCall.Death");
		callback.add(CallbackMsgCTurretKill,"DioGrabCall.Death");
		callback.add(CallbackMsgOOBKill,"DioGrabCall.Death");
		callback.add(CallbackMsgCampKill,"DioGrabCall.Death");
		callback.add(CallbackMsgLightningKill,"DioGrabCall.Death");
		callback.add(CallbackMsgLavaKill,"DioGrabCall.Death");
		callback.add(CallbackMsgExplosionKill,"DioGrabCall.Death");
		callback.add(CallbackMsgRogueMineKill,"DioGrabCall.Death");			
	}
	
	function DioGrabCall::MakeHud(){
		if(!isObject(DioGrabCallHUD)){			
			%x = getWord($pref::Video::resolution, 0)-190;
			%y = getWord(hudClusterBack.position, 1)+90;
			
			new ShellFieldCtrl(DioGrabCallHUD) {
				profile = "GuiChatBackProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = %x SPC %y;
				extent = "190 20";
				minExtent = "8 8";
				visible = "0";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
			};
			DioGrabCallHUD.Graphic = new GuiBitmapCtrl() {
				profile = "guidefaultprofile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "6 0";
				extent = "9 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				wrap = "0";
				bitmap = "gui/dgcflag.png";
			};
			DioGrabCallHUD.Timer = new GuiTextCtrl() {
				profile = "DGCTimerWhite";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "17 2";				
				extent = "23 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "10";
				longTextBuffer = "0";
				maxLength = "255";
			};
			DioGrabCallHUD.Caller =	new GuiMLTextCtrl() {
				profile = "DGCCallerWhite";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "42 2";
				extent = "135 20";
				minExtent = "8 8";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "";
				longTextBuffer = "0";
				maxLength = "255";
			};
			
			DioGrabCallHUD.add(DioGrabCallHUD.Caller);
			DioGrabCallHUD.add(DioGrabCallHUD.Timer);
			DioGrabCallHUD.add(DioGrabCallHUD.Graphic);
			PlayGui.add(DioGrabCallHUD);
			
			if (isObject(HM) && isObject(HudMover)){
				hudmover::addhud(DioGrabCallHUD, "DioGrabCall");
			}
		}
	}
	
	function LoadingGui::onWake( %this ){
		DioGrabCall.makehud();
		parent::onwake(%this);
	}
	
};
activatePackage(DioGrabCall);

if($AutoloadExecuted)
	DioGrabCall.setup();